=== debian/changelog ===
scalapack (2.2.2-2) unstable; urgency=medium

  * add debian patches applying upstream patches
    - cmake4_PR123.patch applies upstream PR#124 to update
      required cmake versions. Closes: #1113484
    - fix_C23_gcc15_PR139.patch applies upstream PR#139 to
      fix build with gcc-15 (C23). Closes: #1097848.
  * debian patch blacs_no_testing.patch deactivates BLACS/TESTING,
    which is currently broken. Also REDIST/TESTING. Skip BLACS/TESTING
    in debian/scalapack-mpi-test.install. See Bug#1097848 and
    https://github.com/Reference-ScaLAPACK/scalapack/issues/148
  * enable s390x build tests via oversubscribe. Closes: #1095323.
  * set myself as Uploader. Closes: #1107179.
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Nov 2025 18:51:09 +0100

scalapack (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches pblas_testing.patch
      and scalapack_testing.patch
    - updates cmake config to SCALAPACK_BUILD_TESTS
      not SCALAPACK_BUILD_TESTING
  * most of debian patch blacs_testing.patch is now applied upstream
  * drop debian patch restore_mpifort_revert_PR39.patch (MPI build is
    fixed by upstream MRs #57 and #67)

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Jan 2025 20:47:15 +0100

scalapack (2.2.1-7) unstable; urgency=medium

  * Team upload.
  * provide 64-bit definition for Depends: ${scalapack64-mpi-dev}
    (defined as the build for the default MPI)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Nov 2024 01:47:43 +0100

scalapack (2.2.1-6) unstable; urgency=medium

  * Team upload.
  * OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
    Use the new variable name in debian/rules.
  * Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the
    environment variable PRTE_MCA_plm_ssh_agent is set at build time in
    debian/rules.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 20 Nov 2024 09:58:49 +0000
