=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%scalapack-$1.tar.gz%" \
 https://github.com/Reference-ScaLAPACK/scalapack/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
